#ifndef __PROCESS_H    /*  An extra safeguard to prevent this header from  */
#define __PROCESS_H    /*  being included twice in the same source file    */

#include <string>
#include "mystic_struct.h"

using namespace std;

/*--------------------------------------------------------------------------------*/
// Globals
//struct ListItem  *MyList  = 0 ;   // holds all user data
//struct ListItem1 *MyList1 = 0 ;   // Sorts All Users by Top Calls / Uploads
//struct ListItem2 *MyList2 = 0 ;   // Sorts All Users by Top Posts / Downloads

/*--------------------------------------------------------------------------------*/
// LINK LISTS - Functions to Clear All Alloclated Memory
/*--------------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------------*/
// Clears ListItem
void clearuserdata(void);

/*--------------------------------------------------------------------------------*/
// Clears ListItem1
void clearuserdata1(void);

/*--------------------------------------------------------------------------------*/
// Clears ListItem2
void clearuserdata2(void);

/*--------------------------------------------------------------------------------*/
// Clears Link List and Free's Current Memory
void clearANSI(void);

/*--------------------------------------------------------------------------------*/
// LINK LISTS - Functions To Collect and Sort All Data
/*--------------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------------*/
// Stores all Data Recived into Link List w/out Sorting
void userdatacontainer(UserRec * user);

/*--------------------------------------------------------------------------------*/
// This Receives Users From ListList and Sorts All Users by Calls to the BBS
void ulsort(UserRec * user);

/*--------------------------------------------------------------------------------*/
// This Receives Users From ListList and Sorts All Users by Calls to the BBS
void dlsort(UserRec * user);

/*--------------------------------------------------------------------------------*/
// Functions Reading ANSI Templates, and Parsing MCI Code and Writing Out ANSI STATS
/*--------------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------------*/
// Write out Ansi file for Top Transfers
void writeANSI1();

/*--------------------------------------------------------------------------------*/
// Holds all Parsed ANSI for Writting out to File
void buildANSI(string ansi);

/*--------------------------------------------------------------------------------*/
// Parses MCI Codes for Top Uploaders / Downloaders
void checkMCI1(string ansidata);

/*--------------------------------------------------------------------------------*/
// Read ANSI Template and parse for MCI code
int parseansi1();

/*--------------------------------------------------------------------------------*/
// Functions To Collect and Populate Link List for Data Sorting and Processing
/*--------------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------------*/
// Function to retrive all users/data from Users.dat Populates Linklist
void getusers(void);

/*--------------------------------------------------------------------------------*/
// Kicks off Uploads / Downloads Processing
void proctransfers(void);


/*--------------------------------------------------------------------------------*/
// Functions That kick off all processing
/*--------------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------------*/
// Main Starter Functions for Collecting and Processing all Data
void doallproc(void);

#endif
